#include "read_and_upload_db.h"

char query[300];

int main(void)
{
      int rc = 0,ch = 0;
      MQTTClient client;
      MQTTClient_connectOptions conn_opts = MQTTClient_connectOptions_initializer;

      // init mysql conexion and socket conexion
      mysql_app_init();
      sprintf(query,"TRUNCATE TABLE motes");
      mysql_query_execute(query);

      MQTTClient_create(&client, ADDRESS, CLIENTID,
			MQTTCLIENT_PERSISTENCE_NONE, NULL);
      conn_opts.keepAliveInterval = 20;
      conn_opts.cleansession = 1;
      MQTTClient_setCallbacks(client, NULL, connlost, msgarrvd, delivered);
      if ((rc = MQTTClient_connect(client, &conn_opts)) != MQTTCLIENT_SUCCESS)
      {
	    printf("Failed to connect, return code %d\n", rc);
	    exit(EXIT_FAILURE);
      }
      printf("Subscribing to topic %s\nfor client %s using QoS%d\n\n"
	     "Press Q<Enter> to quit\n\n", TOPIC, CLIENTID, QOS);
      MQTTClient_subscribe(client, TOPIC, QOS);
      do
      {
	    ch = getchar();
      } while(ch!='Q' && ch != 'q');
      MQTTClient_disconnect(client, 10000);
      MQTTClient_destroy(&client);
      return 0;
}

void delivered(void *context, MQTTClient_deliveryToken dt)
{
      printf("Message with token value %d delivery confirmed\n", dt);
      deliveredtoken = dt;
}

int msgarrvd(void *context, char *topicName, int topicLen, MQTTClient_message *message)
{
      int i;
      char* payloadptr;
      printf("Message arrived\n");
      printf("     topic: %s\n", topicName);
      printf("   message: ");
      payloadptr = message->payload;
      for(i=0; i<message->payloadlen; i++)
      {
	    putchar(*payloadptr++);
      }
      putchar('\n');
      payloadptr = message->payload;
      mysql_prepare_query_insert(query,payloadptr);
      mysql_query_execute(query);
      MQTTClient_freeMessage(&message);
      MQTTClient_free(topicName);
      return 1;
}

void connlost(void *context, char *cause)
{
      printf("\nConnection lost\n");
      printf("     cause: %s\n", cause);
}

void mysql_prepare_query_insert(char* query,char *buf){
      uint32_t num;
      char fecha[50];
      num = (uint32_t)buf[1] << 8 | (uint32_t)buf[0];
      int number = (int)num;

      printf("Data: %d\n" , number);

      time_t t = time(NULL);
      struct tm tm = *localtime(&t);

      sprintf(fecha,
	      "%d-%d-%d %d:%d:%d",
	      tm.tm_year + 1900,
	      tm.tm_mon + 1,
	      tm.tm_mday,
	      tm.tm_hour,
	      tm.tm_min,
	      tm.tm_sec);
      sprintf(query,
	      "INSERT INTO motes (number,fecha) VALUES (%d,'%s')",
	      number,
	      fecha);
}

void mysql_app_init(void){
      conn = mysql_init(NULL);
      if (!mysql_real_connect(conn, server, user, password, database, 0, NULL, 0)){
	    die((char *)mysql_error(conn));
      }
}

void mysql_query_execute(char *query){
      if (mysql_query(conn, query)){
	    die((char *)mysql_error(conn));
      }
}

void die(char *s){
      perror(s);
      exit(1);
}
