#ifndef __MRANDOM_H
#define __MRANDOM_H

/**
\addtogroup AppUdp
\{
\addtogroup mrandom
\{
*/

#include "opentimers.h"
#include "openudp.h"

//=========================== define ==========================================

#define MRANDOM_PERIOD_MS 30000

//=========================== typedef =========================================

//=========================== variables =======================================

typedef struct {
   opentimers_id_t      timerId;  ///< periodic timer which triggers transmission
   uint16_t             counter;  ///< incrementing counter which is written into the packet
   uint16_t              period;  ///< uinject packet sending period>
   udp_resource_desc_t     desc;  ///< resource descriptor for this module, used to register at UDP stack
} mrandom_vars_t ;

//=========================== prototypes ======================================

void mrandom_init(void);
void mrandom_receive(OpenQueueEntry_t* msg);
void mrandom_sendDone(OpenQueueEntry_t* msg, owerror_t error);
/**
\}
\}
*/

#endif
