#ifndef __OPENMQTT_H
#define __OPENMQTT_H

/**
\addtogroup Transport
\{
\addtogroup openMQTT
\{
*/

#include "openudp.h"
#include "MQTTSNConnect.h"
#include "MQTTSNPacket.h"
#include "MQTTSNPublish.h"

//=========================== define ==========================================

#define FAILURE -1
#define SUCCESS 0
#define NO_RADIO -2
#define IS_DAGROOT -3
#define IS_CONNECTED -4
#define PUBACK -5
#define MAX_PACKET_SIZE 100
#define MQTTSN_MIN_PACKET_LENGTH 2

//=========================== typedef =========================================


//=========================== module variables ================================

typedef struct {
   udp_resource_desc_t          desc;
   bool                         busySending;
   uint8_t                      delayCounter;
   uint16_t                     messageID;
} openmqtt_vars_t;

//=========================== prototypes ======================================

// from stack
void          openmqtt_init(void);
void          openmqtt_receive(OpenQueueEntry_t* msg);
void          openmqtt_sendDone(OpenQueueEntry_t* msg, owerror_t error);
uint8_t       openmqtt_sendPackage(uint8_t *buff,uint16_t lenght);
uint8_t       openmqtt_connect(uint8_t *openmqtt_dst_addr,uint8_t id,
			       MQTTSNString *Topic_ini,
			       MQTTSNString *Msg_ini);
uint8_t       openmqtt_publish(MQTTSN_topicid *topic,
			       uint8_t *payload, uint16_t length);
bool          openmqtt_isConnected(void);
uint8_t       openmqtt_disconnect(void);

/**
\}
\}
*/

#endif
