#include "read_and_upload_db.h"

int main(void)
{
   struct sockaddr_in6 si_me, si_other;
   int s, i, slen = sizeof(si_other) , recv_len;
   char buf[BUFLEN];
   char query[300];
   char straddr[INET6_ADDRSTRLEN];

   // init mysql conexion and socket conexion
   mysql_app_init();
   s = socket_init(&si_me);
   sprintf(query,"TRUNCATE TABLE motes");
   mysql_query_execute(query);

   //keep listening for data
   while(1){
      printf("Waiting for data...\n");
      fflush(stdout);
      //try to receive some data, this is a blocking call
      socket_send_amd_receive(&s,buf,&si_other,&slen,&recv_len,true);

      //print details of the client/peer and the data received
      printf("Received packet from %s:%d\n",
	     inet_ntop(AF_INET6, &si_other.sin6_addr, straddr, sizeof(straddr)),
	     ntohs(si_other.sin6_port));
      mysql_prepare_query_insert(query,buf,straddr);
      mysql_query_execute(query);
   }
   close(s);
   return 0;
}

void mysql_prepare_query_insert(char* query,char *buf,char *straddr){
   uint32_t num;
   char fecha[50];
   num = (uint32_t)buf[1] << 8 | (uint32_t)buf[0];
   int number = (int)num;

   printf("Data: %d\n" , number);
   char aux[INET6_ADDRSTRLEN];
   strcpy(aux,straddr);
   char *token;
   token = strtok (aux,":");
   char *lastToken ;
   while (token != NULL){
     lastToken = token ;
     token = strtok (NULL, ":");
   }

   time_t t = time(NULL);
   struct tm tm = *localtime(&t);

   sprintf(fecha,
	   "%d-%d-%d %d:%d:%d",
	   tm.tm_year + 1900,
	   tm.tm_mon + 1,
	   tm.tm_mday,
	   tm.tm_hour,
	   tm.tm_min,
	   tm.tm_sec);
   sprintf(query,
	   "INSERT INTO motes (ip6,mote,number,fecha) VALUES ('%s','%s',%d,'%s')",
	   straddr,
	   lastToken,
	   number,
	   fecha);
}

int socket_init(struct sockaddr_in6 *si_me){
   int s = 0;
   //create a UDP socket
   if ((s=socket(PF_INET6, SOCK_DGRAM, 0)) == -1){
      die("socket");
   }
   // zero out the structure
   memset((char *)si_me, 0, sizeof(si_me));
   si_me->sin6_family = AF_INET6;
   si_me->sin6_port = htons(PORT);
   si_me->sin6_addr = in6addr_any;
   //bind socket to port
   if( bind(s,(struct sockaddr *)si_me, sizeof(*si_me) ) == -1){
      die("bind");
   }
   return s;
}

void socket_send_amd_receive(int *s,
			     char *buf,
			     struct sockaddr_in6 *si_other,
			     int *slen,
			     int *recv_len,
			     bool send_receive){
   if(send_receive){
     if ((*recv_len = recvfrom(*s, buf, BUFLEN, 0, (struct sockaddr *)si_other, slen)) == -1){
	die("recvfrom()");
     }
   } else {
     if (sendto(*s, buf, *recv_len, 0, (struct sockaddr*)si_other, *slen) == -1){
	die("sendto()");
     }
   }
}

void mysql_app_init(void){
  conn = mysql_init(NULL);
  if (!mysql_real_connect(conn, server, user, password, database, 0, NULL, 0)){
     die((char *)mysql_error(conn));
  }
}

void mysql_query_execute(char *query){
   if (mysql_query(conn, query)){
      die((char *)mysql_error(conn));
   }
}

void die(char *s){
   perror(s);
   exit(1);
}
