#ifndef __URANDOM_H
#define __URANDOM_H

/**
\addtogroup AppUdp
\{
\addtogroup urandom
\{
*/

#include "opentimers.h"
#include "openudp.h"

//=========================== define ==========================================

#define URANDOM_PERIOD_MS 65535

//=========================== typedef =========================================

//=========================== variables =======================================

typedef struct {
   opentimers_id_t      timerId;  ///< periodic timer which triggers transmission
   uint16_t             counter;  ///< incrementing counter which is written into the packet
   uint16_t              period;  ///< uinject packet sending period>
   udp_resource_desc_t     desc;  ///< resource descriptor for this module, used to register at UDP stack
} urandom_vars_t,urandom_vars_send_t,urandom_vars_receive_t ;

//=========================== prototypes ======================================

void urandom_init(void);
void urandom_receive(OpenQueueEntry_t* msg);
void urandom_sendDone(OpenQueueEntry_t* msg, owerror_t error);
/**
\}
\}
*/

#endif
